<?php
	
	declare(strict_types=1);
		
	/**
	 * User: Daschmi (daschmi@daschmi.de)
	 * Date: 14.01.2020
	 * Time: 07:20
	 */
	
	class wpsg_mod_printshop extends wpsg_mod_basic {
		
		protected static $instance = null;
		private $set_data = null;
		
		const MODE_AREA = 1;
		const MODE_AREA_SELECT = 2;
		const MODE_LFM = 3;
		const MODE_LFM_SELECT = 4;
		
		var $id = 5501;
		
		/**
		 * Kostructor
		 */
		public function __construct() {
			
			parent::__construct();
			
			$this->name = __('Druckerei', 'wpsg');
			$this->group = __('Produkte', 'wpsg');
			$this->desc = __('', 'wpsg');
			
		} 
		
		public function settings_edit() {
			
			$this->shop->render(WPSG_PATH_VIEW.'/mods/mod_printshop/settings_edit.phtml');
			
		}
		
		public function product_addedit_content(&$product_content, &$product_data) {
			
			// Nur für angelegte Produkte
			if ($product_data['id'] <= 0) return false;
			 			
			$oProduct = wpsg_product::getInstance($product_data['id']);
			
			$this->shop->view['wpsg_mod_printshop'] = [];

            $this->shop->view['wpsg_mod_printshop']['set'] = intval($oProduct->getMeta('wpsg_mod_printshop_set'));
            $this->shop->view['wpsg_mod_printshop']['mode'] = intval($oProduct->getMeta('wpsg_mod_printshop_mode'));
            $this->shop->view['wpsg_mod_printshop']['unit_price'] = sanitize_text_field($oProduct->getMeta('wpsg_mod_printshop_unit_price'));
            $this->shop->view['wpsg_mod_printshop']['unit_input'] = sanitize_text_field($oProduct->getMeta('wpsg_mod_printshop_unit_input'));
            $this->shop->view['wpsg_mod_printshop']['factor_price_input'] = sanitize_text_field($oProduct->getMeta('wpsg_mod_printshop_factor_price_input'));
            $this->shop->view['wpsg_mod_printshop']['width_step'] = intval($oProduct->getMeta('wpsg_mod_printshop_width_step'));
            $this->shop->view['wpsg_mod_printshop']['width_min'] = intval($oProduct->getMeta('wpsg_mod_printshop_width_min'));
            $this->shop->view['wpsg_mod_printshop']['width_max'] = intval($oProduct->getMeta('wpsg_mod_printshop_width_max'));
            $this->shop->view['wpsg_mod_printshop']['length_step'] = intval($oProduct->getMeta('wpsg_mod_printshop_length_step'));
            $this->shop->view['wpsg_mod_printshop']['length_min'] = intval($oProduct->getMeta('wpsg_mod_printshop_length_min'));
            $this->shop->view['wpsg_mod_printshop']['length_max'] = intval($oProduct->getMeta('wpsg_mod_printshop_length_max'));
            $this->shop->view['wpsg_mod_printshop']['width'] = wpsg_tf($oProduct->getMeta('wpsg_mod_printshop_width'));
            $this->shop->view['wpsg_mod_printshop']['width'] = wpsg_tf($oProduct->getMeta('wpsg_mod_printshop_width'));
            $this->shop->view['wpsg_mod_printshop']['productupload_set'] = intval($oProduct->getMeta('wpsg_mod_printshop_productupload_set')) > 0;
            $this->shop->view['wpsg_mod_printshop']['productupload_length'] = intval($oProduct->getMeta('wpsg_mod_printshop_productupload_length'));
            $this->shop->view['wpsg_mod_printshop']['productupload_mandatory'] = intval($oProduct->getMeta('wpsg_mod_printshop_productupload_mandatory')) > 0;

			$product_content['wpsg_mod_printshop'] = [
				'title' => __('Druckereiprodukt', 'wpsg'),
				'content' => $this->shop->render(WPSG_PATH_VIEW.'/mods/mod_printshop/produkt_addedit_content.phtml', false)
			];
			
		}

        /**
         * @param $product_id
         * @throws Exception
         */
		public function produkt_save(&$product_id) {

		    $r = [
                'set' => intval(@$_REQUEST['wpsg_mod_printshop']['set']),
		        'mode' => intval(@$_REQUEST['wpsg_mod_printshop']['mode']),
                'unit_price' => sanitize_text_field(@$_REQUEST['wpsg_mod_printshop']['unit_price']),
                'unit_input' => sanitize_text_field(@$_REQUEST['wpsg_mod_printshop']['unit_input']),
                'factor_price_input' => wpsg_tf($_REQUEST['wpsg_mod_printshop']['factor_price_input']),
                'width' => wpsg_tf(@$_REQUEST['wpsg_mod_printshop']['width']),
                'width_step' => intval(@$_REQUEST['wpsg_mod_printshop']['width_step']),
                'width_min' => intval(@$_REQUEST['wpsg_mod_printshop']['width_min']),
                'width_max' => intval(@$_REQUEST['wpsg_mod_printshop']['width_max']),
                'length_step' => intval(@$_REQUEST['wpsg_mod_printshop']['length_step']),
                'length_min' => intval(@$_REQUEST['wpsg_mod_printshop']['length_min']),
                'length_max' => intval(@$_REQUEST['wpsg_mod_printshop']['length_max']),
                'productupload_set' => intval(@$_REQUEST['wpsg_mod_printshop']['productupload_set']),
                'productupload_length' => intval(@$_REQUEST['wpsg_mod_printshop']['productupload_length']),
                'productupload_mandatory' => intval(@$_REQUEST['wpsg_mod_printshop']['productupload_mandatory']),
            ];

		    if ($r['mode'] > 0) {

                $oProduct = wpsg_product::getInstance($product_id);

                $oProduct->setMeta('wpsg_mod_printshop_set', $r['set']);
                $oProduct->setMeta('wpsg_mod_printshop_mode', $r['mode']);
                $oProduct->setMeta('wpsg_mod_printshop_unit_price', $r['unit_price']);
                $oProduct->setMeta('wpsg_mod_printshop_unit_input', $r['unit_input']);
                $oProduct->setMeta('wpsg_mod_printshop_factor_price_input', $r['factor_price_input']);

                if ($r['mode'] === self::MODE_AREA) {

                } else if ($r['mode'] === self::MODE_AREA_SELECT) {

                    $oProduct->setMeta('wpsg_mod_printshop_width_step', $r['width_step']);
                    $oProduct->setMeta('wpsg_mod_printshop_width_min', $r['width_min']);
                    $oProduct->setMeta('wpsg_mod_printshop_width_max', $r['width_max']);

                    $oProduct->setMeta('wpsg_mod_printshop_length_step', $r['length_step']);
                    $oProduct->setMeta('wpsg_mod_printshop_length_min', $r['length_min']);
                    $oProduct->setMeta('wpsg_mod_printshop_length_max', $r['length_max']);
                    
                } else if ($r['mode'] === self::MODE_LFM) {

                    $oProduct->setMeta('wpsg_mod_printshop_width', $r['width']);

                } else if ($r['mode'] === self::MODE_LFM_SELECT) {

                    $oProduct->setMeta('wpsg_mod_printshop_width', $r['width']);
                    $oProduct->setMeta('wpsg_mod_printshop_length_step', $r['length_step']);
                    $oProduct->setMeta('wpsg_mod_printshop_length_min', $r['length_min']);
                    $oProduct->setMeta('wpsg_mod_printshop_length_max', $r['length_max']);

                } else throw \wpsg\Exception::getInvalidValueException();

                $oProduct->setMeta('wpsg_mod_printshop_productupload_set', $r['productupload_set']);
                $oProduct->setMeta('wpsg_mod_printshop_productupload_length', $r['productupload_length']);
                $oProduct->setMeta('wpsg_mod_printshop_productupload_mandatory', $r['productupload_mandatory']);

            }

		}

        /**
         * @throws Exception
         */
		public function basket_preInsert() {

		    $r = [
		        'insertAreaProduct' => intval($_REQUEST['wpsg']['insertAreaProduct']??0),
                'product_key' => sanitize_text_field($_REQUEST['wpsg']['product_key']??''),
                'menge' => intval($_REQUEST['wpsg']['menge']??0),
                'length' => wpsg_tf($_REQUEST['wpsg']['length']??0),
                'width' => wpsg_tf($_REQUEST['wpsg']['width']??0)
            ];

			if ($r['insertAreaProduct'] > 0) {
			
				$oProduct = wpsg_product::getInstance($r['product_key']);

				if (intval($oProduct->getMeta('wpsg_mod_printshop_set')) === 1) {
					
					$price_onepice = $oProduct->getPrice($r['product_key']);
						
					$mode = intval($oProduct->getMeta('wpsg_mod_printshop_mode'));
					$factor = wpsg_tf($oProduct->getMeta('wpsg_mod_printshop_factor_price_input'));

					if ($mode === wpsg_mod_printshop::MODE_AREA) {

                        $length = $r['length'];
                        $width = $r['width'];

                    } else if ($mode === wpsg_mod_printshop::MODE_AREA_SELECT) {

                        $arWidth = [];
                        $arLength = [];

                        for ($i = intval($oProduct->getMeta('wpsg_mod_printshop_width_min')); $i <= intval($oProduct->getMeta('wpsg_mod_printshop_width_max')); $i += intval($oProduct->getMeta('wpsg_mod_printshop_width_step'))) {

                            $arWidth[] = $i;

                        }

                        for ($i = intval($oProduct->getMeta('wpsg_mod_printshop_length_min')); $i <= intval($oProduct->getMeta('wpsg_mod_printshop_length_max')); $i += intval($oProduct->getMeta('wpsg_mod_printshop_length_step'))) {

                            $arLength[] = $i;

                        }

                        if (in_array($r['width'], $arWidth)) $width = $r['width']; else throw \wpsg\Exception::getInvalidValueException();
                        if (in_array($r['length'], $arLength)) $length = $r['length']; else throw \wpsg\Exception::getInvalidValueException();

                    } else if ($mode === wpsg_mod_printshop::MODE_LFM) {

                        $length = $r['length'];
                        $width = wpsg_tf($oProduct->getMeta('wpsg_mod_printshop_width'));

                    } else if ($mode === self::MODE_LFM_SELECT) {

                        $arLength = [];

                        for ($i = intval($oProduct->getMeta('wpsg_mod_printshop_length_min')); $i <= intval($oProduct->getMeta('wpsg_mod_printshop_length_max')); $i += intval($oProduct->getMeta('wpsg_mod_printshop_length_step'))) {

                            $arLength[] = $i;

                        }

                        if (in_array($r['length'], $arLength)) $length = $r['length']; else throw \wpsg\Exception::getInvalidValueException();

						$width = wpsg_tf($oProduct->getMeta('wpsg_mod_printshop_width'));

					} else throw wpsg\Exception::getInvalidFunctionException();

                    $price = round(($width * $factor) * ($r['length'] * $factor), 2) * $price_onepice;

					$this->set_data = [
						'price' => $price,
						'width' => $width,
						'length' => $length						
					];

				} else throw wpsg\Exception::getInvalidFunctionException();
								
			}
			
		}
		
		public function basket_produkttosession($produkt_key, &$menge, &$ses_data) {
			
			if ($this->set_data !== null) {
				
				$ses_data['wpsg_mod_printshop'] = $this->set_data;

				$this->set_data = null;
				
			}
			
		}

        public function basket_row_before(&$p, $i) {

		    $oProduct = wpsg_product::getInstance($p['id']);

            if (intval($oProduct->getMeta('wpsg_mod_printshop_set')) === 1) {

                $this->shop->view['wpsg_mod_printshop'] = [
                    'width' => wpsg_tf($p['wpsg_mod_printshop']['width']),
                    'length' => wpsg_tf($p['wpsg_mod_printshop']['length']),
                    'price_onepice' => $oProduct->getPrice($p['product_key']),
                    'unit_input' => sanitize_text_field($oProduct->getMeta('wpsg_mod_printshop_unit_input')),
                    'unit_price' => sanitize_text_field($oProduct->getMeta('wpsg_mod_printshop_unit_price')),
                    'factor_price_input' => wpsg_tf($oProduct->getMeta('wpsg_mod_printshop_factor_price_input'))
                ];

                $factor = wpsg_tf($oProduct->getMeta('wpsg_mod_printshop_factor_price_input'));

                $this->shop->view['wpsg_mod_printshop']['area'] = round(($this->shop->view['wpsg_mod_printshop']['width'] * $factor) * ($this->shop->view['wpsg_mod_printshop']['length'] * $factor), 2);

                $this->shop->render(WPSG_PATH_VIEW.'/mods/mod_printshop/basket_row_before.phtml');

            }

        }

        public function basket_row(&$p, $i) {

            $oProduct = wpsg_product::getInstance($p['id']);

            if (intval($oProduct->getMeta('wpsg_mod_printshop_productupload_set')) === 1) {

                $this->shop->view['wpsg_mod_printshop'] = [
                    'length' => wpsg_tf($oProduct->getMeta('wpsg_mod_printshop_productupload_length')),
                    'mandatory' => wpsg_tf($oProduct->getMeta('wpsg_mod_printshop_productupload_mandatory')),
                    'product_index' => $p['product_index'],
                    'files' => wpsg_getArray($p['wpsg_mod_printshop']['files'])
                ];

                $this->shop->render(WPSG_PATH_VIEW.'/mods/mod_printshop/basket_row.phtml');

            }

        }

        public function order_ajax() {

		    if (wpsg_isSizedString($_REQUEST['do'], 'download')) {

		        $r = [
		            'do' => 'download',
		            'mod' => 'wpsg_mod_printshop',
                    'noheader' => '1',
		            'order_id' => intval($_REQUEST['order_id']),
                    'product_index' => intval($_REQUEST['product_index']),
                    'file' => sanitize_file_name(rawurldecode($_REQUEST['file']))
                ];

                wpsg_checkNounce('Order', 'ajax', $r);

                $path = $this->getUploadPath($r['order_id'], $r['product_index'], false).basename($r['file']);

                if (file_exists($path)) {

                    wpsg_header::AUTO($path, $r['file']);
                    exit;

                }

            }

        }

        public function template_redirect() {

		    if (get_the_ID() === intval($this->shop->get_option('wpsg_page_basket')) &&
                (isset($_REQUEST['wpsg_basket_refresh']) || isset($_REQUEST['wpsg_basket_submit']))) {

                foreach (wpsg_getArray($_SESSION['wpsg']['basket']) as $product_index => $product_data) {

                    $oProduct = wpsg_product::getInstance($product_data['id']);

                    if ($oProduct->getMeta('wpsg_mod_printshop_productupload_set') === '1') {

                        if (!isset($_SESSION['wpsg']['basket'][$product_index]['wpsg_mod_printshop']['files'])) $_SESSION['wpsg']['basket'][$product_index]['wpsg_mod_printshop']['files'] = [];

                        // Dateien löschen
                        foreach (wpsg_getArray($_REQUEST['wpsg_mod_printshop'][$product_index]['delete_file']) as $file_index) {

                            if (isset($_SESSION['wpsg']['basket'][$product_index]['wpsg_mod_printshop']['files'][$file_index])) {

                                unlink($_SESSION['wpsg']['basket'][$product_index]['wpsg_mod_printshop']['files'][$file_index]['tmpnam']);
                                unset($_SESSION['wpsg']['basket'][$product_index]['wpsg_mod_printshop']['files'][$file_index]);

                            }

                        }

                        // Dateien hinzufügen
                        foreach (wpsg_getArray($_FILES['wpsg_mod_printshop']['error'][$product_index]) as $file_index => $error_code) {

                            if (intval($error_code) === 0) {

                                $tmpnam = tempnam(sys_get_temp_dir(), 'wpsg_mod_printshop');

                                move_uploaded_file($_FILES['wpsg_mod_printshop']['tmp_name'][$product_index][$file_index], $tmpnam);

                                $_SESSION['wpsg']['basket'][$product_index]['wpsg_mod_printshop']['files'][] = [
                                    'tmpnam' => $tmpnam,
                                    'file_name' => $_FILES['wpsg_mod_printshop']['name'][$product_index][$file_index]
                                ];

                            }

                        }

                    }

                }

            }

        }

        public function checkBasket(&$ok) {

		    foreach (wpsg_getArray($_SESSION['wpsg']['basket']) as $product_index => $product_data) {

		        $oProduct = wpsg_product::getInstance($product_data['id']);

		        if ($oProduct->getMeta('wpsg_mod_printshop_productupload_set') === '1') {

                    if (!isset($_SESSION['wpsg']['basket'][$product_index]['wpsg_mod_printshop']['files'])) $_SESSION['wpsg']['basket'][$product_index]['wpsg_mod_printshop']['files'] = [];

                    // Maximalanzahl prüfen
                    $max_upload = intval($oProduct->getMeta('wpsg_mod_printshop_productupload_length'));

                    if ($max_upload > 0 && sizeof($_SESSION['wpsg']['basket'][$product_index]['wpsg_mod_printshop']['files']) > $max_upload) {

                        $this->shop->addFrontendError(wpsg_translate(
                            __('Anzahl an Uploads (#1#) in Produkt "#2#" überschreitet die maximal mögliche Menge an Uploads (#3#).', 'wpsg'),
                            sizeof($_SESSION['wpsg']['basket'][$product_index]['wpsg_mod_printshop']['files']),
                            $oProduct->getProductName(),
                            $max_upload,
                        ));

                        $ok = false;

                    }

                    // Pflichtfeld überprüfen
                    if ($oProduct->getMeta('wpsg_mod_printshop_productupload_mandatory') === '1') {

                        if (sizeof($_SESSION['wpsg']['basket'][$product_index]['wpsg_mod_printshop']['files']) == 0) {

                            $this->shop->addFrontendError(wpsg_translate(
                                __('Sie müssen mindestens eine Datei zu Produkt "#1#" hochladen.', 'wpsg'),
                                $oProduct->getProductName()
                            ));

                            $ok = false;

                        }

                    }

                }

            }

        } // public function checkCheckout(&$state, &$error, &$arCheckout)

        public function order_view_row_before(&$p, $i) {

            $oProduct = wpsg_product::getInstance($p['product_id']);
            $oOrderProduct = wpsg_order_product::getInstance($p['order_product_id']);

            if (intval($oProduct->getMeta('wpsg_mod_printshop_set')) === 1) {

                $this->shop->view['wpsg_mod_printshop'] = [
                    'order_id' => $oOrderProduct->getOrder()->getId(),
                    'product_index' => $oOrderProduct->getProductIndex(),
                    'i' => intval($i),
                    'width' => wpsg_tf($oOrderProduct->getMeta('wpsg_mod_printshop_width')),
                    'length' => wpsg_tf($oOrderProduct->getMeta('wpsg_mod_printshop_length')),
                    'price_onepice' => wpsg_tf($oOrderProduct->getMeta('wpsg_mod_printshop_price_onepice')),
                    'unit_price' => sanitize_text_field($oOrderProduct->getMeta('wpsg_mod_printshop_unit_price')),
                    'unit_input' => sanitize_text_field($oOrderProduct->getMeta('wpsg_mod_printshop_unit_input')),
                    'factor_price_input' => wpsg_tf($oProduct->getMeta('wpsg_mod_printshop_factor_price_input')),
                    'arFiles' => $this->getFiles($oOrderProduct->getOrder()->getId(), $oOrderProduct->getProductIndex())
                ];

                $factor = wpsg_tf($oProduct->getMeta('wpsg_mod_printshop_factor_price_input'));

                $this->shop->view['wpsg_mod_printshop']['area'] = round(($this->shop->view['wpsg_mod_printshop']['width'] * $factor) * ($this->shop->view['wpsg_mod_printshop']['length'] * $factor), 2);

                $this->shop->render(WPSG_PATH_VIEW.'/mods/mod_printshop/order_view_row.phtml');

            }

        }

        public function mail_row($i, $p) {

            //$this->htmlMail = true;

            $oProduct = wpsg_product::getInstance($p['product_id']);
            $oOrderProduct = wpsg_order_product::getInstance($p['order_product_id']);

            if (intval($oProduct->getMeta('wpsg_mod_printshop_set')) === 1) {

                $this->shop->view['wpsg_mod_printshop'] = [
                    'i' => intval($i),
                    'width' => wpsg_tf($oOrderProduct->getMeta('wpsg_mod_printshop_width')),
                    'length' => wpsg_tf($oOrderProduct->getMeta('wpsg_mod_printshop_length')),
                    'price_onepice' => wpsg_tf($oOrderProduct->getMeta('wpsg_mod_printshop_price_onepice')),
                    'unit_input' => sanitize_text_field($oProduct->getMeta('wpsg_mod_printshop_unit_input')),
                    'unit_price' => sanitize_text_field($oProduct->getMeta('wpsg_mod_printshop_unit_price')),
                    'factor_price_input' => wpsg_tf($oProduct->getMeta('wpsg_mod_printshop_factor_price_input'))
                ];

                $factor = wpsg_tf($oProduct->getMeta('wpsg_mod_printshop_factor_price_input'));

                $this->shop->view['wpsg_mod_printshop']['area'] = round(($this->shop->view['wpsg_mod_printshop']['width'] * $factor) * ($this->shop->view['wpsg_mod_printshop']['length'] * $factor), 2);

                if ($this->shop->htmlMail === true)
                    $this->shop->render(WPSG_PATH_VIEW.'/mods/mod_printshop/mail_row_html.phtml');
                else
                    $this->shop->render(WPSG_PATH_VIEW.'/mods/mod_printshop/mail_row.phtml');

            }

        }

        public function overview_row_before(&$p, $i) {

            $oProduct = wpsg_product::getInstance($p['id']);

            if (intval($oProduct->getMeta('wpsg_mod_printshop_set')) === 1) {

                $this->shop->view['wpsg_mod_printshop'] = [
                    'width' => wpsg_tf($p['wpsg_mod_printshop']['width']),
                    'length' => wpsg_tf($p['wpsg_mod_printshop']['length']),
                    'price_onepice' => $oProduct->getPrice($p['product_key']),
                    'unit_input' => sanitize_text_field($oProduct->getMeta('wpsg_mod_printshop_unit_input')),
                    'unit_price' => sanitize_text_field($oProduct->getMeta('wpsg_mod_printshop_unit_price')),
                    'factor_price_input' => wpsg_tf($oProduct->getMeta('wpsg_mod_printshop_factor_price_input'))
                ];

                $factor = wpsg_tf($oProduct->getMeta('wpsg_mod_printshop_factor_price_input'));

                $this->shop->view['wpsg_mod_printshop']['area'] = round(($this->shop->view['wpsg_mod_printshop']['width'] * $factor) * ($this->shop->view['wpsg_mod_printshop']['length'] * $factor), 2);

                $this->shop->render(WPSG_PATH_VIEW.'/mods/mod_printshop/overview_row_before.phtml');

            }

        }

        public function overview_row(&$p, $i) {

            $oProduct = wpsg_product::getInstance($p['id']);

            if (intval($oProduct->getMeta('wpsg_mod_printshop_productupload_set')) === 1 && wpsg_isSizedArray($p['wpsg_mod_printshop']['files'])) {

                $this->shop->view['wpsg_mod_printshop'] = [
                    'length' => wpsg_tf($oProduct->getMeta('wpsg_mod_printshop_productupload_length')),
                    'mandatory' => wpsg_tf($oProduct->getMeta('wpsg_mod_printshop_productupload_mandatory')),
                    'product_index' => $p['product_index'],
                    'files' => $p['wpsg_mod_printshop']['files']
                ];

                $this->shop->render(WPSG_PATH_VIEW.'/mods/mod_printshop/overview_row.phtml');

            }

        }

        public function basket_save_done(&$order_id, &$kunde_id, &$oBasket) {

		    $oOrder = wpsg_order::getInstance($order_id);

		    foreach ($oOrder->getOrderProducts() as $oOrderProduct) {

		        if ($oOrderProduct->getProduct()->getMeta('wpsg_mod_printshop_productupload_set') === '1') {

                    $product_index = $oOrderProduct->getProductIndex();

                    if (wpsg_isSizedArray($_SESSION['wpsg']['basket'][$product_index]['wpsg_mod_printshop']['files'])) {

                        $path = $this->getUploadPath($order_id, $product_index);

                        foreach ($_SESSION['wpsg']['basket'][$product_index]['wpsg_mod_printshop']['files'] as $f) {

                            copy($f['tmpnam'], $path.$f['file_name']);

                        }

                    }

                }

            }

        }

		public function calculation_addProduct(&$product_data, $ses_data) {
			
			if (isset($ses_data['wpsg_mod_printshop'])) {
				
				$product_data['set'] = $ses_data['wpsg_mod_printshop']['price'];
				$product_data['bruttonetto'] = $this->shop->getBackendTaxview();
				 
			}
			
		}

        public function renderProdukt_templateSelect(&$produkt_data, &$template_file) {

            $oProduct = wpsg_product::getInstance($produkt_data['id']);

            if (intval($oProduct->getMeta('wpsg_mod_printshop_set')) === 1) {

                $template_file = WPSG_PATH_VIEW.'/mods/mod_printshop/producttemplate.phtml';

            }

        }

        public function calculation_saveProduct_after(&$oCalculation, $calc_product, &$db_product_data, $finish_order) {

		    $oProduct = wpsg_product::getInstance($calc_product['product_id']);

            if (intval($oProduct->getMeta('wpsg_mod_printshop_set')) === 1) {

		        $ac = $_SESSION['wpsg']['basket'][$calc_product['product_index']]['wpsg_mod_printshop']??null;

		        if (is_null($ac)) throw new \wpsg\Exception(__('Keine Daten zum speichern des Flächenproduktes'));

		        if (!isset($ac['price']) || !isset($ac['width']) || !isset($ac['length'])) throw new \wpsg\Exception(__('Es fehlen Daten zum speichern des Flächenproduktes'));

                $oOrderProduct = wpsg_order_product::getInstance(intval($calc_product['order_product_id']));

                $oOrderProduct->setMeta('wpsg_mod_printshop_price', wpsg_tf($ac['price']));
                $oOrderProduct->setMeta('wpsg_mod_printshop_width', wpsg_tf($ac['width']));
                $oOrderProduct->setMeta('wpsg_mod_printshop_length', wpsg_tf($ac['length']));
                $oOrderProduct->setMeta('wpsg_mod_printshop_price_onepice', wpsg_tf($oProduct->getPrice($calc_product['product_key'])));
                $oOrderProduct->setMeta('wpsg_mod_printshop_unit_price', sanitize_text_field($oProduct->getMeta('wpsg_mod_printshop_unit_price')));

            }

        }

        public function downloadFileRedirect() {

            $product_index = intval($_REQUEST['product_index']);
            $file_index = intval($_REQUEST['file_index']);

		    $file = wpsg_getStr($_SESSION['wpsg']['basket'][$product_index]['wpsg_mod_printshop']['files'][$file_index]['tmpnam']);

		    if (file_exists($file)) {

		        wpsg_header::AUTO(
		            $file,
                    wpsg_getStr($_SESSION['wpsg']['basket'][$product_index]['wpsg_mod_printshop']['files'][$file_index]['file_name'])
                );

            } else {

		        $this->shop->addFrontendError(__('Datei konnte nicht gefunden werden.', 'wpsg'));
		        $this->shop->redirect($this->shop->getURL(wpsg_ShopController::URL_BASKET));

            }

        }

        /**
         * @param int $order_id
         * @param int $product_index
         * @param bool $create
         * @return string
         */
        public function getUploadPath($order_id, $product_index, $create = true) {

            $path = WPSG_PATH_UPLOADS.'wpsg_mod_printshop/files/'.$order_id.'/'.$product_index.'/';

            if ($create) $this->shop->protectDirectory($path);

            return $path;

        }

        public function getFiles($order_id, $product_index) {

            $arFiles = [];
            $path = $this->getUploadPath($order_id, $product_index, false);

            if (file_exists($path)) {

                foreach (scandir($path) as $f) {

                    if (!in_array($f, ['.', '..', '.htaccess'])) {

                        $arFiles[] = $path.$f;

                    }

                }

            }

		    return $arFiles;

        }

		/* Statische Funktionen */

		public static function getInstance() {
			
			if (!isset(static::$instance)) static::$instance = new static;
			
			return static::$instance;
			
		}

	}
    
    